
{% macro add_product_to_cart(main_class="basket-message") %}
    <div class="{{ main_class }}">
        <div class="text-wrap">
            <div class="success-msg">
                <i class="fa fa-check" aria-hidden="true"></i>
                <p>{% trans %}Product added to cart{% endtrans %}</p>
            </div>
            <div class="error-msg">
                <i class="fa fa-warning" aria-hidden="true"></i>
                <p id="error-msg"></p>
            </div>
        </div>
    </div>
    {{ product_to_basket_js(main_class) }}
{% endmacro %}

{% macro product_to_basket_js(main_class) %}
    <script>
        function updateNavigationBasket() {
            $.ajax({
                url: "{{ url('shuup:xtheme_extra_view', view='basket_partial') }}",
                method: "GET",
                success: function(basket_html) {
                    var $basket_html = $(basket_html);
                    $basket_html.find("input[name='return']").each(function(idx, el) {
                        $(el).val("{{ request.path }}");
                    });
                    $("#navigation-basket-partial").html($basket_html)
                }
            });
        }

        function handleMessageHiding(cover, btn) {
            // Remove spinner icon from the button and enable it again
            $("#btn-spinner").remove();
            btn.attr("disabled", false);

            setTimeout(function() {
                // Hide the message and the modal after 3 seconds
                cover.removeClass("in error");
                cover.removeAttr("role");
            }, 3000);
        }

        function handleError(cover, errorMsg, btn) {
            // change to error message
            cover.addClass('in error');

            var msg = "{% trans %}There was an error adding the product to the basket{% endtrans %}";
            cover.find("#error-msg").text(errorMsg ? errorMsg : msg);

            handleMessageHiding(cover, btn);
        }

        function handleSuccess(cover, btn) {
            // show the message
            cover.addClass("in");

            updateNavigationBasket();

            handleMessageHiding(cover, btn);
        }

        function addToBasket(form) {
            var cover = $(".{{ main_class }}");

            cover.removeClass("in error"); // Reset if clicked multiple times in a row
            cover.attr("role", "alert");

            var btn = $(form).find("button[id*='add-to-cart']");
            if (!btn.length) {
                btn = $(form).find("button[class*='add-to-cart']")
            }

            btn.prepend("<i id='btn-spinner' class='fa fa-spin fa-spinner'></i>").attr("disabled", true);

            $.ajax({
                url: form.attr("action"),
                method: "POST",
                data: form.serializeArray(),
                success: function(response) {
                    if(response.error) {
                        handleError(cover, response.error, btn);
                        return;
                    }
                    handleSuccess(cover, btn);
                },
                error: function() {
                    handleError(cover, null, btn);
                }
            });
        }

        $(document).ready(function() {
            $(document).on("submit", "form.add-to-basket", function(e) {
                e.preventDefault();
                addToBasket($(this));
            });
        });
    </script>
{% endmacro %}
